package w83b.w83bOperacionesInternas.w83bActas;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import w83b.w83bBeans.W83bActasBean;
import w83b.w83bBeans.W83bUsuarioXLNetsBean;
import w83b.w83bUtilidadesComunes.W83bClsConstantes;
import es.ejie.frmk.negocio.operacioninterna.Q70OperacionInterna;
import es.ejie.frmk.negocio.operacioninterna.Q70OperacionInternaConfigBean;
import es.ejie.frmk.negocio.operacioninterna.Q70OperacionInternaErrors;
import es.ejie.frmk.presentacion.sesiondatos.Q70ContextoEJIE;
/**
 * 
 * @author 
 *
 */
public class W83bDetalleActasOIAction extends Q70OperacionInterna{
	/**
	 * preProcessMappingEntrada
	 * @param contexto a
	 * @param configBean a
	 * @param errors a
	 * @throws Exception e
	 */				
	protected void preProcessMappingEntrada(Q70ContextoEJIE contexto, Q70OperacionInternaConfigBean configBean, Q70OperacionInternaErrors errors) throws Exception{
		W83bActasBean acta=new W83bActasBean();
		List listaActas = (ArrayList)contexto.get("w83bListaActas");
		String codSelec=((String)((HashMap)contexto.get("w83bMapaActas")).get("codSelec")).replaceAll("/", "_");
		if(codSelec.length()<=6){//estamos dando de alta
			acta=(W83bActasBean)contexto.get("w83bNuevaActaBean");
		}
		else{//estamos editando
			String[] seleccionado = codSelec.split("_");
			acta.setNumActaTerritorio(seleccionado[0]);
			acta.setNumActaAno(seleccionado[1]);
			acta.setNumActa(seleccionado[2]);
			W83bActasBean actaSeleccionada = (W83bActasBean)listaActas.get(Integer.parseInt(seleccionado[3]));
			acta.setVersion(actaSeleccionada.getVersion());
		}
		acta.setIdioma((String)contexto.get(W83bClsConstantes.CONSTANTE_CONTEXTO_IDIOMA));
		acta.setUsuarioBean((W83bUsuarioXLNetsBean)contexto.get(W83bClsConstantes.CONSTANTE_CONTEXTO_USUARIO));
		
		if("incidencias".equals((String)contexto.get("w83bSubOpFlag"))){
			acta.setPestana("incidencias");
		}
		
		contexto.set("codSelec",codSelec);
		contexto.set("w83bNuevaActaBean",acta);
		super.preProcessMappingEntrada(contexto, configBean, errors);
			
	}
	/**
	 * postProcessMappingSalida
	 * @param contexto a
	 * @param errors a
	 * @throws Exception e
	 */
	protected void postProcessMappingSalida(Q70ContextoEJIE contexto, Q70OperacionInternaErrors errors) throws Exception {
		contexto.set("modoPantalla",W83bClsConstantes.MODO_EDICION);
		contexto.set("w83bColegiosBean",((W83bActasBean)contexto.get("w83bNuevaActaBean")).getColegios());
		contexto.set("w83bNuevaActaBean",contexto.get("w83bNuevaActaBean"));
		
		super.postProcessMappingSalida(contexto, errors);
	}
	
}
